/*************************************************************************\
*
*  emu48.h
*
*  Main header file
*
*  (c)2002 by Robert Hildinger
*
\*************************************************************************/


// Event Codes
#define displayChangeEvent					0x6100
#define volumeUnmountedEvent 				0x6101
#define volumeMountedEvent 					0x6102
#define invokeColorSelectorEvent			0x6103


/***********************************************************************
 *
 *	Internal Constants
 *
 ***********************************************************************/
 
#define sxStateFileName			"HP48SXStatefile"
#define sxStateFileType			'staF'
#define gxStateFileName			"HP48GXStatefile"
#define gxStateFileType			'staF'
#define g49StateFileName		"HP49GStatefile"
#define g49StateFileType		'staF'

#define VFSROMRAMDirectory		"/PALM/PROGRAMS/Power48/"
#define sxVFSROMFileName		"/PALM/PROGRAMS/Power48/HP48SXRomfile.bin"
#define sxVFSRAMFileName		"/PALM/PROGRAMS/Power48/HP48SXRamfile.bin"
#define sxVFSPORT1FileName		"/PALM/PROGRAMS/Power48/HP48SXPort1file.bin"
#define gxVFSROMFileName		"/PALM/PROGRAMS/Power48/HP48GXRomfile.bin"
#define gxVFSRAMFileName		"/PALM/PROGRAMS/Power48/HP48GXRamfile.bin"
#define gxVFSPORT1FileName		"/PALM/PROGRAMS/Power48/HP48GXPort1file.bin"
#define g49VFSROMFileName		"/PALM/PROGRAMS/Power48/HP49GRomfile.bin"
#define g49VFSIRAMFileName		"/PALM/PROGRAMS/Power48/HP49GIRamfile.bin"
#define g49VFSERAMFileName		"/PALM/PROGRAMS/Power48/HP49GERamfile.bin"

#define romMemSXFtrNum 			100
#define romMemGXFtrNum 			101
#define romMem49FtrNum			102
#define ramMemSXFtrNum			103
#define ramMemGXFtrNum 			104
#define ramMem49FtrNum			105

#define tempObjMemFtrNum 		200


/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(3,5,0,sysROMStageDevelopment,0)
#define ourMaxVersion    sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)

// Error Codes
#define errUnableToAllocateRAM				0x8000
#define errUnableToLoadROMFile				0x8001
#define errUnableToLoadRAMFile				0x8002
#define errUnableToFindROMFiles				0x8003





#define XM 1
#define SB 2
#define SR 4
#define MP 8

//#define CRC(nib)      crc=(crc>>4)^(((crc^(nib))&0xf)*0x1081);

#define SAVEPC         asm { move.l a1,pc_save }
#define RESTOREPC      asm { move.l pc_save,a1 }
#define DECREMENTPC    asm { subq.l %1,a1 }
#define PCMINUSONE     asm { subq.l %1,a1 }
#define PCMINUSTWO     asm { subq.l %2,a1 }
#define PCMINUSTHREE   asm { subq.l %3,a1 }
#define PCMINUSFOUR    asm { subq.l %4,a1 }
#define PCPLUSONE      asm { addq.l %1,a1 }
#define PCPLUSTWO      asm { addq.l %2,a1 }
#define PCPLUSTHREE    asm { addq.l %3,a1 }
#define PCPLUSFOUR     asm { addq.l %4,a1 }
#define PCPLUSd0       asm { add.l  d0,a1 }
#define PCMINUSd0      asm { sub.l  d0,a1 }



//#define INCLUDE_PROFILER   // Don't use PROFILER and TRACER at same time
//#define INCLUDE_TRACER
//#define PRINT_IPS

#ifdef INCLUDE_PROFILER
	#define ENABLE_CLEAR_BUTTON
	extern UInt32 time[500];
	extern UInt32 count[500];
#endif

#ifdef INCLUDE_TRACER
	#define ENABLE_CLEAR_BUTTON
	extern Boolean collecting;
	extern FileHand tracerStream;
	extern UInt32 traceNum;
#endif

#ifdef PRINT_IPS
extern void update_ips(void);
extern UInt32 instCount;
extern UInt32 lastTicks;
extern UInt32 previousCount;
#endif


#define noKey				99

#define softKeyA			0
#define softKeyB			1
#define softKeyC			2
#define softKeyD			3
#define softKeyE			4
#define softKeyF			5

#define keyMTH				6
#define keyPRG				7
#define keyCST				8
#define keyVAR				9
#define keyUp				10
#define keyNXT				11

#define keyQuote			12
#define keySTO				13
#define keyEVAL				14
#define keyLEFT				15
#define keyDOWN				16
#define keyRIGHT			17

#define keySIN				18
#define keyCOS				19
#define keyTAN				20
#define keySquareRoot		21
#define keyYtotheX			22
#define key1OverX			23

#define keyENTER			24
#define keyPlusMinus		25
#define keyEEX				26
#define keyDEL				27
#define keyBackspace		28

#define keyAlpha			29
#define key7				30
#define key8				31
#define key9				32
#define keyDivide			33

#define keyLeftShift		34
#define key4				35
#define key5				36
#define key6				37
#define keyMultiply			38

#define keyRightShift		39
#define key1				40
#define key2				41
#define key3				42
#define keySubtract			43

#define keyON				44
#define key0				45
#define keyPeriod			46
#define keySPC				47
#define keyAdd				48

#define keyAPPS				49
#define keyMODE				50
#define keyTOOL				51
#define keyHIST				52
#define keyCAT				53
#define keyEQW				54
#define keySYMB				55
#define keyX				56

#define keyDropMenu			57
#define keyLauncher			58
#define keyAbout48GX		59
#define keyOnPlus			60
#define keyObject			61
#define keySwitch			62

#ifdef ENABLE_CLEAR_BUTTON
	#define keyClear		63
	#define maxKeys			64
#else
	#define maxKeys			63
#endif

#define virtKeyBase				0x80

#define virtKeySoftKeyA			0x80
#define virtKeySoftKeyB			0x81
#define virtKeySoftKeyC			0x82
#define virtKeySoftKeyD			0x83
#define virtKeySoftKeyE			0x84
#define virtKeySoftKeyF			0x85
#define virtKeyLabelNxt			0x86
#define virtKeyLabelPrev		0x87

#define maxVirtKeys				8

#define virtKeyVideoSwap		0x88   // don't include in max


#define EDGE_EXPANSION  2   // number of pixels past edge of button


#define noPref						99

#define prefGeneral					0
#define pref48GX					1
#define pref48SX					2	
#define pref49G						3
#define prefCancel					4
#define prefOK						5
#define prefGenCPUDoze				6	
#define prefGenHiResPlus			7
#define prefGenTurbo				8   // UNUSED
#define prefGenVerbose				9
#define prefGenVerboseSlow			10
#define prefGenVerboseFast			11
#define prefGenVolUp				12
#define prefGenVolDown				13
#define prefGenReset				14
#define prefGenColorSelect			15
#define pref48GXBackdrop			16
#define pref48GXColorCycle			17	
#define pref48GX128KExpansion		18
#define pref48GXActive				19
#define pref48SXBackdrop			20
#define pref48SXColorCycle			21
#define pref48SX128KExpansion		22
#define pref48SXActive				23
#define pref49GBackdrop				24
#define pref49GColorCycle			25
#define pref49GActive				26

#define maxPrefButtons 				27



#define noObject			99

#define objectLoad 			0
#define objectSave 			1
#define objectCancel		2
#define objectOK			3
#define objectList			4
#define objectUp			5
#define objectDown			6

#define maxObjectButtons 	7



#define noAlertConfirmButton	99

#define AlertConfirmNO			0
#define AlertConfirmYESorOK		1

#define maxAlertConfirmButtons 	2



#define noColorButton				99

#define colorCancel					0
#define colorDefault				1
#define colorOK						2	
#define colorBackRed				3
#define colorBackGreen				4
#define colorBackBlue				5
#define colorPixelRed				6	
#define colorPixelGreen				7
#define colorPixelBlue				8

#define maxColorButtons 			9




#define READ_SEGMENT_SIZE 		256
#define WRITE_SEGMENT_SIZE 		512    /// i.e. READ_SEGMENT_SIZE*2

#define RAM_SIZE_GX 				0x40000
#define ROM_SIZE_GX 				0x100000
#define RAM_SIZE_SX 				0x10000
#define ROM_SIZE_SX 				0x080000
#define PORT1_SIZE					0x40000
#define IRAM_SIZE_49				0x080000
#define ERAM_SIZE_49				0x080000
#define ROM_SIZE_49					0x200000

#define SATURN_INSTRUCTIONS_PER_TICK	60

#define TIME_OFFSET		0x0001bfa9d9700000


extern char A[16];
extern char B[16];
extern char C[16];
extern char D[16];
extern char R0[16];
extern char R1[16];
extern char R2[16];
extern char R3[16];
extern char R4[16];
extern char ST[4];

extern char HST;
extern char  P;
extern int  OUT, IN;
extern int  SHUTDN, WAKEUP, INTP, INTE, INTD, rstkp, MODE, MODE_MINUS_ONE;
extern UInt8 CARRY;
extern long rstk[8];
extern long pc_reg;
extern long d0reg, d1reg;
extern UInt8 F_s[16];
extern UInt8 F_l[16];
extern char CARDSTATUS;

extern UInt32 pc_save;

extern Boolean 	mcIOAddrConfigured;
extern long 	mcIOBase;
extern long 	mcIOCeil;

extern Boolean 	mcRAMSizeConfigured;
extern Boolean 	mcRAMAddrConfigured;
extern long 	mcRAMBase;
extern long		mcRAMCeil;
extern long		mcRAMSize;
extern long		mcRAMDelta;

extern Boolean 	mcCE1SizeConfigured;
extern Boolean 	mcCE1AddrConfigured;
extern long 	mcCE1Base;
extern long		mcCE1Ceil;
extern long		mcCE1Size;
extern long		mcCE1Delta;

extern Boolean 	mcCE2SizeConfigured;
extern Boolean 	mcCE2AddrConfigured;
extern long 	mcCE2Base;
extern long		mcCE2Ceil;
extern long		mcCE2Size;
extern long		mcCE2Delta;

extern Boolean 	mcNCE3SizeConfigured;
extern Boolean 	mcNCE3AddrConfigured;
extern long 	mcNCE3Base;
extern long		mcNCE3Ceil;
extern long		mcNCE3Size;
extern long		mcNCE3Delta;

extern char *rom, *ram, *port1, *port2;
extern char *ce1addr, *ce2addr, *nce3addr;
extern char ioram[64];
extern char *flashAddr[16];
extern int  flashBankLo,flashBankHi;
extern char *flashRomLo,*flashRomHi;

extern UInt16	crc;
extern UInt8 	t1;
extern UInt32 	t2;
extern UInt16 	saturn_speed;

extern UInt16 prevTimeStamp;    // dragonball high resolution timer used for Saturn Timer 2
extern UInt32 prevTickStamp;    // PalmOS 10ms low resolution timer used for Saturn Timer 1

extern Boolean delayRefresh;
extern UInt16  delayEvent;
extern UInt16  delayKey;
extern UInt16  delayEvent2;
extern UInt16  delayKey2;
extern Int16   update_t1;

extern volatile UInt16 *timeReg;

extern int IO_TIMER_RUN;


typedef enum
{
	HP48SX,
	HP48GX,
	HP49G
} calcTarget;

typedef enum
{
	alert=1,
	confirm
} dialogType;

typedef enum
{
	STARTUP,
	SWITCH,
	SHUTDOWN,
	ANY
} ProgBarType; 


extern calcTarget  	optionTarget;
extern Boolean 		optionPowerSave;
extern Boolean 		optionVerbose;
extern Boolean 		optionScrollFast;
extern Boolean 		option320x320;
extern UInt16 		optionVolume;
extern Boolean	 	option48GXBackdrop;
extern Boolean	 	option48SXBackdrop;
extern Boolean	 	option49GBackdrop;
extern Boolean	 	option48GXColorCycle;
extern Boolean	 	option48SXColorCycle;
extern Boolean	 	option49GColorCycle;
extern Boolean	 	option48GX128KExpansion;
extern Boolean	 	option48SX128KExpansion;
extern RGBColorType	option48GXPixelColor;
extern RGBColorType	option48GXBackColor;
extern RGBColorType	option48SXPixelColor;
extern RGBColorType	option48SXBackColor;
extern RGBColorType	option49GPixelColor;
extern RGBColorType	option49GBackColor;

typedef struct {
	UInt16		volume;
	Boolean 	loadSX;
	Boolean 	powerSave;
	Boolean 	verbose;
	Boolean 	scrollFast;
	Boolean 	o320x320;
	Boolean	 	o48GXBackdrop;
	Boolean	 	o48SXBackdrop;
	Boolean	 	o49GBackdrop;
	Boolean	 	o48GXColorCycle;
	Boolean	 	o48SXColorCycle;
	Boolean	 	o49GColorCycle;
	Boolean	 	o48GX128KExpansion;
	Boolean	 	o48SX128KExpansion;
	calcTarget	target;
	RGBColorType	o48GXPixelColor;
	RGBColorType	o48GXBackColor;
	RGBColorType	o48SXPixelColor;
	RGBColorType	o48SXBackColor;
	RGBColorType	o49GPixelColor;
	RGBColorType	o49GBackColor;
} pref_t;

typedef struct {
	UInt16		volume;
	Boolean 	loadSX;
	Boolean 	powerSave;
	Boolean 	verbose;
	Boolean 	scrollFast;
	Boolean 	turbo;
	Boolean 	o320x320;
	Boolean	 	o48GXColorForContrast;
	Boolean	 	o48SXColorForContrast;
	Boolean	 	o48GXWhiteBackground;
	Boolean	 	o48SXWhiteBackground;
	Boolean	 	o48GX128KExpansion;
	Boolean	 	o48SX128KExpansion;
} pref_t_090b;                     // version 0.90 beta pref format

extern Boolean		statusQuit;                 // non-saved
extern Boolean 		statusCompleteReset;
extern Boolean 		statusSwitchEmulation;
extern Boolean 		status128KExpansion;
extern Boolean 		statusDisplayMode2x2;
extern Boolean		statusBackdrop;
extern Boolean 		statusColorCycle;
extern Boolean		status48SXROMAvailable;
extern Boolean		status48GXROMAvailable;
extern Boolean		status49GROMAvailable;
extern Boolean		statusVolumeMounted;
extern Boolean		statusInUnmountDialog;
extern Boolean		statusRUN;
extern Boolean		statusPendingGUISwitch;
extern Boolean		statusSkipScreenDraw;
extern UInt8		statusPrefTabActive;
extern UInt8		statusObjectLSActive;
extern Boolean		status49GActive;
extern calcTarget 	statusNextTarget;
extern Boolean		statusPerformReset;
extern RGBColorType	*statusPixelColor;
extern RGBColorType	*statusBackColor;


extern long		lcdDisplayAddressStart;
extern long		lcdDisplayAddressStart2;
extern long		lcdDisplayAddressEnd;
extern long		lcdMenuAddressStart;
extern long		lcdMenuAddressEnd;
extern int 		lcdDisplayAreaWidth;
extern int		lcdCurrentLine;
extern int		lcdLineCount;
extern int 		lcdByteOffset;
extern int 		lcdContrastLevel;
extern int 		lcdPixelOffset;
extern int		lcdAnnunciatorState;
extern int 		lcdPreviousAnnunciatorState;
extern int 		lcdOn;
extern int 		lcdTouched;
extern char*	lcdLineAddress[64];
extern UInt8	lcdRedrawBuffer[64];

extern UInt8 kbd_row[9];
extern int IR15X;





extern void emulate(void);
extern Boolean write_io_multiple(long d, char *a, int s);

extern void init_lcd(void);
extern void exit_lcd(void);
extern void build_contrast_map(void);
extern void build_quick_color_contrast_map(RGBColorType *pixRGB, RGBColorType *bgRGB);
extern void display_clear(void);
extern void change_ann(RGBColorType *annPixelRGBColor, RGBColorType *annBackRGBColor);
extern void adjust_contrast(void);
extern void kbd_handler(UInt16 keyIndex, int press, Boolean translate);
extern void update_in(void);
extern void update_out(void);
extern void toggle_lcd(void);
extern void rect_sweep(RectangleType *oldRect,RectangleType *newRect, int numSteps);
extern void ResetTime(void);
extern void AdjustTime(void);

extern void RecalculateDisplayParameters(void);
extern void DrawDisplayLine16x2(void);
extern void DrawDisplayLine16x1(void);

extern UInt16 msVolRefNum;
extern UInt16 hrLibRefNum;
extern UInt16 silkLibRefNum;
extern Boolean silkInUse;
extern WinHandle mainDisplayWindow;
extern WinHandle backStoreWindow;
extern WinHandle hp48NibbleToScreenWindow1x1;	
extern WinHandle hp48NibbleToScreenWindow2x2;	
extern WinHandle annunciatorBitmapWindow;	
extern WinHandle nibbleMap1x1;	
extern WinHandle nibbleMap2x2;	
extern WinHandle checkBoxWindow;	
extern WinHandle greyBackStore;
extern RGBColorType backRGB,textRGB;
extern UInt32 *contrastPixel2Map[16];
extern UInt16 *contrastPixel1Map[16];
extern UInt32 *nibbleMap2x2Base;
extern UInt16 *nibbleMap1x1Base;

extern const RGBColorType redRGB;
extern const RGBColorType greenRGB;
extern const RGBColorType blueRGB;
extern const RGBColorType whiteRGB;
extern const RGBColorType blackRGB;
extern const RGBColorType greyRGB;

#define lcdOriginX			46
#define lcdOriginY			17
#define fullScreenOriginX   46
#define fullScreenOriginY   3
#define fullScreenExtentX   262
#define fullScreenExtentY   142
#define lcd1x1OriginX		169
#define lcd1x1OriginY		3
#define lcd1x1FSOriginX		167
#define lcd1x1FSOriginY		3
#define lcd1x1FSExtentX		133
#define lcd1x1FSExtentY		64
#define lcd1x1AnnOriginX	153
#define lcd1x1AnnOriginY	3
#define lcd1x1AnnExtentX	12
#define lcd1x1AnnExtentY	64
#define lcd1x1DividerOriginX	165
#define lcd1x1DividerOriginY	3
#define lcd1x1DividerExtentX	2
#define lcd1x1DividerExtentY	64
#define lcd1x1TotalExtentX	148
#define lcd1x1TotalExtentY	64

#define lcdRows 			64
#define lcdColumns			131
#define displayRows			lcdRows*2
#define displayColumns		lcdColumns*2
#define screenPrintOriginX	lcdOriginX+2
#define screenPrintOriginY	lcdOriginY-13
#define screenPrintExtentX	displayColumns-4
#define screenPrintExtentY	displayRows+13
#define errorPrintOriginX	lcdOriginX+2
#define errorPrintOriginY	210
#define errorPrintExtentX	displayColumns
#define errorPrintExtentY	230
#define errorPrint320ExtentY	100
#define lineDiff			11
#define prefDialogOriginX	19
#define prefDialogOriginY	13
#define prefDialogExtentX	282
#define prefDialogExtentY	294
#define colorDialogOriginX	23
#define colorDialogOriginY	160
#define colorDialogExtentX	274
#define colorDialogExtentY	154

#define annunciator2x2OriginX		46
#define annunciator1x1OriginX		154
#define annunciator2x2OriginY		4
#define annunciator1x1OriginY		3
#define annunciatorBitmapWidth		60
#define annShiftLeftOffset			0
#define ann2x2ShiftLeftPositionX	14
#define ann1x1ShiftLeftPositionY	0
#define annShiftRightOffset			10
#define ann2x2ShiftRightPositionX	54
#define ann1x1ShiftRightPositionY	11
#define annAlphaOffset				20
#define ann2x2AlphaPositionX		94
#define ann1x1AlphaPositionY		22
#define annAlarmOffset				30
#define ann2x2AlarmPositionX		134
#define ann1x1AlarmPositionY		33
#define annBusyOffset				40
#define ann2x2BusyPositionX			190
#define ann1x1BusyPositionY			44
#define annIOOffset					50
#define ann2x2IOPositionX			230
#define ann1x1IOPositionY			55
#define annHeight					10

typedef struct
{
	UInt16		upperLeftX;
	UInt16		upperLeftY;
	UInt16		lowerRightX;
	UInt16		lowerRightY;
	UInt8		row;
	UInt8		mask;
} keyDef;

typedef struct
{
	UInt16		upperLeftX;
	UInt16		upperLeftY;
	UInt16		lowerRightX;
	UInt16		lowerRightY;
} squareDef;

typedef struct
{
	UInt16		upperLeftX;
	UInt16		upperLeftY;
	UInt16		lowerRightX;
	UInt16		lowerRightY;
	UInt8		scope;
} prefButton;

typedef struct
{
	UInt16		upperLeftX;
	UInt16		upperLeftY;
	UInt16		lowerRightX;
	UInt16		lowerRightY;
	UInt8		scope;
} objectButton;

typedef struct
{
	Int16		deltaX;
	Int16		deltaY;
} point;

extern const 	keyDef 	keyLayout480[];
extern const 	keyDef 	keyLayout480_hp49[];
extern const 	keyDef 	keyLayout320[];
extern const 	keyDef 	keyLayout320_hp49[];
extern keyDef*	keyLayout;
extern squareDef	keyToSquare[maxKeys];

extern const 	squareDef virtLayout2x2[];
extern const 	squareDef virtLayout1x1[];
extern squareDef*	virtLayout;


extern void* 	GetObjectPtr(UInt16 objectID);
extern void		DisplayHP48Screen(calcTarget loadTarget);
extern void 	AdjustWindowBounds(void);
extern void 	FastDrawBitmap(BitmapPtr sourceBitmap, Coord x, Coord y);
extern void 	PixelDissolve(WinHandle fromWin, WinHandle toWin, UInt32 limit, UInt32 fromOffset, UInt32 toOffset, Boolean transparent);
extern void 	ErrorPrint( char* screenText, Boolean newLine );
extern void 	ScreenPrint( char* screenText, Boolean newLine );
extern void 	ScreenPrintReset(void);
extern Boolean 	SaveRAM(Boolean skipToPort1);
extern UInt16 	TranslatePenToKey(Int16 x, Int16 y);
extern void 	RestoreBottomThird(void);
extern void		CheckForRemount(void);
extern Boolean 	ProcessPalmEvent(EventType *event);
extern void		DepressVirtualKey(UInt16 keyCode);
extern void		ReleaseVirtualKey(UInt16 keyCode);
extern void		DisplayAboutScreen(void);
extern void		DisplayPreferenceScreen(void);
extern void 	ColorSelectorScreen(void);
extern void		DisplaySwitchGraphic(void);
extern void		PinResetEmulator(void);
extern Boolean 	LoadObject(char *fileName);
extern void		OpenObjectLoadSaveDialog(void);
extern Int8 	OpenAlertConfirmDialog(dialogType alertOrConfirm,DmResID stringID,Boolean skipSweep,Boolean skipSave);
extern int		EmulateBeep(void);
extern void 	simulate_keypress(UInt16 keyIndex);
extern void 	GreyOutRectangle(RectangleType opRect, WinHandle win);


#define appFileCreator			'HILD'	// register your own at http://www.palmos.com/dev/creatorid/
#define appName                 "Power48"
#define appVersionNum			"1.0"
#define appPrefID				0x01
#define appPrefVersionNum		0x05
#define appPrefVersionNum_090b	0x02
